SystemOrganization addCategory: #'Qwaq-SharePoint'!

TObject subclass: #QRepositoryInfo
	instanceVariableNames: 'repoType repoUrl repoPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QRepositoryInfo commentStamp: '<historical>' prior: 0!
QRepositoryInfo contains information about a repository location.!

!QRepositoryInfo class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:20'!
repoPath
	"The document name and path inside the repository.
	Depending on repository type, the string may include a path.
	For example, a valid SharePoint document path is 'TeleDocs/sample.pdf'"

	^repoPath! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:20'!
repoPath: aString
	"The document name and path inside the repository.
	Depending on repository type, the string may include a path.
	For example, a valid SharePoint document path is 'TeleDocs/sample.pdf'"

	repoPath := aString! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:19'!
repoType
	"The type of repository. For a list of all known repositories check 
		QDocumentRepository allSubclasses collect: [:cls| cls repoType].
	"

	^repoType! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:20'!
repoType: aString
	"The type of repository. For a list of all known repositories check 
		QDocumentRepository allSubclasses collect: [:cls| cls repoType].
	"

	repoType := aString! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:20'!
repoUrl
	"The URL associated with the document repository. 
	Depending on repository type, the url string may include a path as well.
	For example, a valid SharePoint url is 'http://win2008ad3.qwaq.com/DocTest'"

	^repoUrl! !

!QRepositoryInfo methodsFor: 'accessing' stamp: 'ar 4/15/2010 12:20'!
repoUrl: aString
	"The URL associated with the document repository. 
	Depending on repository type, the url string may include a path as well.
	For example, a valid SharePoint url is 'http://win2008ad3.qwaq.com/DocTest'"

	repoUrl := aString! !

Object subclass: #QCheckinInfo
	instanceVariableNames: 'serverPath repoUrl repoPath repoType upload locked success deleteFile mtime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QCheckinInfo commentStamp: '<historical>' prior: 0!
Information regarding a document check-in.!

!QCheckinInfo class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/14/2010 16:49'!
deleteFile
	"Boolean indicating if the document should be deleted after successful check-in"

	^deleteFile! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/14/2010 16:49'!
deleteFile: aBool
	"Boolean indicating if the document should be deleted after successful check-in"

	deleteFile := aBool! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:45'!
locked
	"If the document was locked and should be unlocked"

	^locked! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:45'!
locked: aBool
	"If the document was locked and should be unlocked"

	locked := aBool! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/14/2010 17:26'!
mtime
	"The original modification of the document. 
	Used to avoid checking in an unmodified document."

	^mtime
! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/14/2010 17:26'!
mtime: seconds
	"The original modification of the document. 
	Used to avoid checking in an unmodified document."

	mtime := seconds! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
repoPath
	"The path in the repository for the check-in"

	^repoPath! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
repoPath: aString
	"The path in the repository for the check-in"

	repoPath := aString! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
repoType
	"The repository type for the check-in"

	^repoType! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:44'!
repoType: aString
	"The repository type for the check-in"

	repoType := aString! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
repoUrl
	"The repository url for the check-in"

	^repoUrl! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
repoUrl: aString
	"The repository url for the check-in"

	repoUrl := aString! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:42'!
serverPath
	"The server location where the document is stored"

	^serverPath! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:43'!
serverPath: aString
	"The server location where the document is stored"

	serverPath := aString! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:45'!
success
	"If the check-in was successfully completed or not"

	^success! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:45'!
success: aBool
	"If the check-in was successfully completed or not"

	success := aBool! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:44'!
upload
	"If the document needs to be uploaded (false when read-only / viewing)"

	^upload! !

!QCheckinInfo methodsFor: 'accessing' stamp: 'ar 4/13/2010 15:44'!
upload: aBool
	"If the document needs to be uploaded (false when read-only / viewing)"

	upload := aBool! !

Object subclass: #QDocumentRepository
	instanceVariableNames: 'url flags mutex owner'
	classVariableNames: 'Cache FlagCheckinInProgress FlagCheckoutInProgress RepoMutex'
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QDocumentRepository commentStamp: '<historical>' prior: 0!
An abstract interface for repository operations.!

!QDocumentRepository class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 4/2/2010 00:06'!
cache
	"Answer the shared cache"

	^Cache ifNil:[Cache := Dictionary new].
! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 4/2/2010 00:06'!
cache: aDictionary
	"Install a shared cache"

	Cache := aDictionary! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 3/31/2010 12:10'!
forType: repoType
	"Return the appropriate class of repository for the given type"

	self allSubclassesDo:[:cls| cls repoType = repoType ifTrue:[^cls]].
	^nil! !

!QDocumentRepository class methodsFor: 'class initialization' stamp: 'ar 4/2/2010 00:32'!
initialize
	"QDocumentRepository initialize"
	FlagCheckoutInProgress := 1.
	FlagCheckinInProgress := 2.
	RepoMutex := Mutex new.! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 4/2/2010 00:34'!
mutex
	"Global mutex to serialize repository operations"

	^RepoMutex! !

!QDocumentRepository class methodsFor: 'instance creation' stamp: 'ar 3/31/2010 12:11'!
on: urlPath
	"Return a new instance pointed to the given url"

	^self new on: urlPath! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 3/31/2010 12:11'!
repoType
	"The type of repostory represented by the receiver"

	^self subclassResponsibility! !

!QDocumentRepository class methodsFor: 'accessing' stamp: 'ar 4/2/2010 00:06'!
resetCache
	"Reset the cache"

	self cache: nil
! !

!QDocumentRepository class methodsFor: 'instance creation' stamp: 'ar 3/31/2010 12:11'!
type: repoType url: repoUrl
	"Return a new repository of given type and url"

	^(self forType: repoType) ifNotNil:[:repoClass| repoClass on: repoUrl].
! !

!QDocumentRepository class methodsFor: 'instance creation' stamp: 'ar 4/5/2010 12:12'!
type: repoType url: repoUrl owner: owner
	"Return a new repository of given type and url"

	^(self type: repoType url: repoUrl) 
		owner: owner;
		yourself! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 4/14/2010 11:33'!
checkValid
	"Verify that the repository location is valid.

	The method checkValid can change the repository url if that is meaningful 
	for the repository. For example, Sharepoint does that."

	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 4/2/2010 00:09'!
checkin: repoPath comment: comment
	"Check in the given document."

	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 17:22'!
checkinInProgress
	"Boolean indicating whether a checkout operation is current in progress"

	^flags anyMask: FlagCheckinInProgress! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 17:21'!
checkinInProgress: aBool
	"Boolean indicating whether a checkin operation is current in progress"

	flags := aBool 
		ifTrue:[flags bitOr: FlagCheckinInProgress] 
		ifFalse:[flags bitClear: FlagCheckinInProgress].! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 4/2/2010 00:12'!
checkout: repoPath do: headerBlock
	"Check out the given document from the repository."

	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 17:20'!
checkoutInProgress
	"Boolean indicating whether a checkout operation is current in progress"

	^flags anyMask: FlagCheckoutInProgress! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 17:21'!
checkoutInProgress: aBool
	"Boolean indicating whether a checkout operation is current in progress"

	flags := aBool 
		ifTrue:[flags bitOr: FlagCheckoutInProgress] 
		ifFalse:[flags bitClear: FlagCheckoutInProgress].! !

!QDocumentRepository methodsFor: 'initialize' stamp: 'ar 4/1/2010 17:41'!
close
	"Close this repository"! !

!QDocumentRepository methodsFor: 'initialize' stamp: 'ar 4/2/2010 00:31'!
critical: aBlock
	^mutex critical: aBlock! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 4/2/2010 00:08'!
download: repoPath do: aBlock
	"Download a document from the repository"

	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 2/19/2010 15:36'!
hasFoldersAt: aPath
	^(self listFolders: aPath) notEmpty! !

!QDocumentRepository methodsFor: 'initialize' stamp: 'ar 4/2/2010 00:30'!
initialize
	"Initialize the reciever"
	flags := 0.
	mutex := Mutex new.! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 2/19/2010 15:20'!
listDocuments: path
	"Retrieve documents from the repository"
	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 2/19/2010 15:20'!
listFolders: path
	"Retrieve folders from the repository"
	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'initialize' stamp: 'ar 2/19/2010 15:28'!
on: urlPath
	self url: urlPath.! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/5/2010 12:12'!
owner
	"The owner (UI) of this repository. 
	Can be nil if the repository is used outside of some UI."

	^owner! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/5/2010 12:13'!
owner: newOwner
	"The owner (UI) of this repository. 
	Can be nil if the repository is used outside of some UI."

	owner := newOwner! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 3/30/2010 17:20'!
refresh
	"Refresh the contents of the repository if is cached"! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 16:50'!
repoType
	"The type of repostory represented by the receiver"

	^self class repoType! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/14/2010 11:20'!
repoUrl
	"The repository url"

	^self url! !

!QDocumentRepository methodsFor: 'actions' stamp: 'ar 4/2/2010 00:07'!
upload: repoPath stream: aStream do: aBlock
	"Upload a document to the repository"

	^self subclassResponsibility! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 16:50'!
url
	"The repository url"

	^url! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/1/2010 16:50'!
url: aString
	"The repository url"

	url := aString! !

!QDocumentRepository methodsFor: 'accessing' stamp: 'ar 4/5/2010 15:42'!
webClient
	"Answer the webClient used to retrieve the contents of the repository"

	^self subclassResponsibility! !

QDocumentRepository subclass: #QSharePointRepository
	instanceVariableNames: 'docMap webClient extension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QSharePointRepository commentStamp: '<historical>' prior: 0!
A SharePoint repository.!

!QSharePointRepository class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSharePointRepository class methodsFor: 'accessing' stamp: 'ar 3/31/2010 12:08'!
repoType
	"The type of repostory represented by the receiver"
	^'sharepoint'! !

!QSharePointRepository methodsFor: 'accessing' stamp: 'ar 4/2/2010 10:28'!
allowAuth
	^webClient allowAuth! !

!QSharePointRepository methodsFor: 'accessing' stamp: 'ar 4/2/2010 10:28'!
allowAuth: aBool
	^webClient allowAuth: aBool! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 4/16/2011 17:45'!
checkResponse: content
	"Check for an error message from a FrontPage RPC response.
	The general format is:

		<html><head><title>vermeer RPC packet</title></head>
<body>

		<p>method=checkout document:12.0.0.6421

		<p>status=

			<ul>

				<li>status=589838

				<li>osstatus=0
				
<li>msg=The file &#34;TeleDocs/Foo.xls&#34; is checked out or locked for editing by FOO&#92;bar.

				<li>osmsg=

			</ul>
		</body></html>
"
	| pIndex status mIndex message code |

	"Find second <p>"
	pIndex := content findString: '<p>' startingAt: 1.
	pIndex = 0 ifTrue:[^nil].
	pIndex := content findString: '<p>' startingAt: pIndex+3.
	pIndex = 0 ifTrue:[^nil].

	"We're at the beginning of a potential status response.
	Verify that it actually is one."
	status := content copyFrom: pIndex+3 to: (content indexOf: $= startingAt: pIndex  ifAbsent:[^nil])-1.
	(status withBlanksTrimmed = 'status') ifFalse:[^nil].

	"It's a status response. Find the msg="
	mIndex := content findString: '<li>msg=' startingAt: pIndex.
	mIndex = 0 ifTrue:[
		QLogger logWarning: 'Unable to parse FPRPC response: ', String cr, content.
		^self error: 'An unknown error was returned (see logs for details)'.
	].
	mIndex := mIndex + '<li>msg=' size.
	message := (content copyFrom: mIndex 
		to: (content indexOf: $< startingAt: mIndex ifAbsent:[content size+1])-1)
			withBlanksTrimmed unescapeHtmlEntities.

	"Find the status code of the error"
	mIndex := content findString: '<li>status=' startingAt: pIndex.
	mIndex = 0 ifTrue:[^self error: message].
	mIndex := mIndex + '<li>status=' size.
	code := (content copyFrom: mIndex 
		to: (content indexOf: $< startingAt: mIndex ifAbsent:[content size+1])-1)
			withBlanksTrimmed asNumber.

	"Check for special codes that we know"
	code caseOf: {
		[589838] -> [^QDocumentIsLocked signal: message]
	} otherwise:[^self error: message].
! !

!QSharePointRepository methodsFor: 'initialize' stamp: 'ar 5/3/2010 11:53'!
checkValid
	"Verify that the repository location is valid"

	| request resp content index siteUrl |
	request := webClient requestWithUrl: url.
	resp := self sendRequest: '/_vti_bin/shtml.dll/_vti_rpc' method: {
		'method' -> 'url to web url:6.0.n.nnnn'.
		'url' -> request url.
		'flags' -> '0'.
	}.
	resp isSuccess ifFalse:[self error: resp status].
	content := resp content.
	index := content findString: '<p>webUrl='.
	index = 0 ifTrue:[
		QLogger logWarning: 'Invalid SharePoint response: ', content.
		^false].
	index := index + '<p>webUrl=' size.
	siteUrl := content copyFrom: index to: (content indexOf: $< startingAt: index)-1.
	siteUrl := 'http://', webClient server, siteUrl withBlanksTrimmed unescapePercents.
	url = siteUrl ifFalse:[
		QLogger logInfo: 'Original url: ', url.
		QLogger logInfo: 'SharePoint site: ', siteUrl.
		url := siteUrl.
	].
	self refresh.
	^true! !

!QSharePointRepository methodsFor: 'initialize' stamp: 'ar 4/1/2010 17:41'!
close
	"Close this repository"
	webClient close.! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2011 17:23'!
commit: repoPath
	"Check in the given document."

	^self commit: repoPath comment: 'Checked in from OpenQwaq'! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2010 11:34'!
commit: repoPath comment: comment
	"Commit in the given document.
	Also releases lock held on it."

	| resp |
	[resp := self sendRequest: url,'/_vti_bin/_vti_aut/author.dll' method: {
		 'method' -> ('checkin document:', self extension).
		'service_name' -> '/'.
		'document_name' -> repoPath.
		'comment' -> comment.
		'keep_checked_out' -> 'true'.
	}.
	resp isSuccess ifFalse:[^self error: resp status].
	self checkResponse: resp content.
	] ensure:[self close].
	^resp! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/2/2010 17:45'!
download: repoPath
	"Download a document from the sharepoint repository.
	Returns the response header; does NOT prefetch its content."

	^self download: repoPath do: nil
! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2011 17:23'!
download: repoPath do: aBlock
	"Download a document from the sharepoint repository.
	Returns the response header; does NOT prefetch its content."

	| request resp |
	request := webClient requestWithUrl: (url, '/', repoPath).
	request method: 'GET'.
	request headerAt: 'User-Agent' put: 'OpenQwaq'.
	aBlock ifNotNil:[aBlock value: request].
	resp := webClient sendRequest: request.
	^resp
! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 3/30/2010 13:07'!
extension
	"Returns the server extension version; fetching it if necessary from the remote"
	^extension ifNil:[self getServerExtension]! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 4/2/2010 11:48'!
getDocument: repoPath
	"List document from server"
	| response |
	response := self sendRequest: url,'/_vti_bin/_vti_aut/author.dll' method: {
		 'method' -> ('get document:', self extension).
		'service_name' -> '/'.
		'document_name' -> repoPath.
		'force' -> 'false'.
		'get_option' -> 'none'.
		'timeout' -> '0'.
	}.
	^response content! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 3/30/2010 14:12'!
getServerExtension
	| response content |
	response := self sendRequest: '/_vti_bin/_vti_aut/author.dll' method: {
		'method' -> 'server version:6.0.2.5614'.
		'service_name' -> '/'.
	}.
	response isSuccess ifFalse:[^self error: response status].
	content := response content.
	extension := String streamContents:[:s|
		#('major ver' 'minor ver' 'phase ver' 'ver incr') do:[:pattern| | index |
			index := (content findString: pattern) + pattern size+1.
			s nextPutAll: (content copyFrom: index to: (content indexOf: $< startingAt: index)-1) withBlanksTrimmed.
		] separatedBy:[s nextPut: $.].
	].
! !

!QSharePointRepository methodsFor: 'contents' stamp: 'ar 4/2/2010 00:10'!
hasFoldersAt: prefix
	"Retrieve documents from the repository"

	| prefixPath  |
	prefixPath := prefix, '/'.
	docMap keysDo:[:path|((path beginsWith: prefixPath) and:[path size > prefix size]) ifTrue:[^true]].
	^false! !

!QSharePointRepository methodsFor: 'initialize' stamp: 'ar 4/14/2010 12:03'!
initialize
	super initialize.
	docMap := Dictionary new.! !

!QSharePointRepository methodsFor: 'contents' stamp: 'ar 4/2/2010 00:10'!
listDocuments: path
	"Retrieve documents from the repository"

	^docMap at: path ifAbsent:[#()].! !

!QSharePointRepository methodsFor: 'contents' stamp: 'ar 4/2/2010 15:34'!
listFolders: prefix
	"Retrieve documents from the repository"

	| prefixPath folderIndex set |
	prefixPath := prefix, '/'.
	set := Set new.
	docMap keysDo:[:path|
		(path beginsWith: prefixPath) ifTrue:[
			folderIndex := path indexOf: $/ startingAt: prefixPath size +1 ifAbsent:[path size+1].
			set add: (path copyFrom: 1 to: folderIndex-1)]].
	^set asArray sort! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 7/20/2010 13:45'!
listServerDocuments: url
	"List documents from server"
	| response stream docs fileInfo fileName fieldStart fieldValue fileSize modifiedBy fileAuthor lastModified fieldEnd |
	response := self sendRequest: url,'/_vti_bin/_vti_aut/author.dll' method: {
		 'method' -> ('list documents:', self extension).
		'service_name' -> ''.
		'listHiddenDocs' -> 'false'.
		'listExplorerDocs' -> 'false'.
"		'platform' -> ''.	"

		'listRecurse' -> 'true'.
		'listFiles' -> 'true'.
		'listFolders' -> 'false'.
		'listLinkInfo' -> 'false'.
		'listIncludeParent' -> 'false'.

		'listDerived' -> 'false'.
		'listBorders' -> 'false'.

"		'validateWelcomeNames' -> 'true'.
		'folderList' -> ''.	"
		'listChildWebs' -> 'false'.

		'initialURL' -> ''.
	}.

	"Extract the documents from the response"
	stream := response content readStream.
	docs := OrderedCollection new.
	stream upToAll: 'document_name='.
	[stream atEnd] whileFalse:[
		fileInfo := [stream upToAll: 'document_name='] 
					on: ConnectionClosed 
					do:[:ex| ex return: stream upToEnd].
		fileName := (fileInfo copyUpTo: $<) withBlanksTrimmed.
		fileName first = $= ifTrue:[fileName := fileName allButFirst withBlanksTrimmed].

		fieldStart := fileInfo findString: 'vti_author'.
		fieldStart > 0 ifTrue:[
			fieldStart := fileInfo findString: '>' startingAt: fieldStart.
			fieldEnd := fileInfo findString: '<' startingAt: fieldStart.
			fieldValue := (fileInfo copyFrom: fieldStart+1 to: fieldEnd-1) withBlanksTrimmed.
			fileAuthor := fieldValue copyAfter: $|.
		].
		fieldStart := fileInfo findString: 'vti_filesize'.
		fieldStart > 0 ifTrue:[
			fieldStart := fileInfo findString: '>' startingAt: fieldStart.
			fieldEnd := fileInfo findString: '<' startingAt: fieldStart.
			fieldValue := (fileInfo copyFrom: fieldStart+1 to: fieldEnd-1) withBlanksTrimmed.
			fileSize := (fieldValue copyAfter: $|) asNumber.
		].
		fieldStart := fileInfo findString: 'vti_modifiedby'.
		fieldStart > 0 ifTrue:[
			fieldStart := fileInfo findString: '>' startingAt: fieldStart.
			fieldEnd := fileInfo findString: '<' startingAt: fieldStart.
			fieldValue := (fileInfo copyFrom: fieldStart+1 to: fieldEnd-1) withBlanksTrimmed.
			modifiedBy := fieldValue copyAfter: $|.
		].
		fieldStart := fileInfo findString: 'vti_timelastmodified '.
		fieldStart > 0 ifTrue:[
			fieldStart := fileInfo findString: '>' startingAt: fieldStart.
			fieldEnd := fileInfo findString: '<' startingAt: fieldStart.
			fieldValue := (fileInfo copyFrom: fieldStart+1 to: fieldEnd-1) withBlanksTrimmed.
			lastModified := fieldValue copyAfter: $|.
		].
		"We really only want the user documents which have a ContentTypeId in SP 2008.
		However, SP2003 does not include this property so instead we only suppress all the
		Microsoft files that end in .aspx"
		"fieldStart := fileInfo findString: 'ContentTypeId'.
		fieldStart > 0 ifTrue:[]."
		(fileName asLowercase endsWith: '.aspx') ifFalse:[
			docs add: {
				fileName. 
				fileSize ifNil:[0]. 
				fileAuthor ifNil:['unknown']. 
				lastModified ifNil:['unknown']. 
				modifiedBy ifNil:['unknown'].
			}.
		].
	].
	^docs! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2010 11:33'!
lock: repoPath
	"Lock the given document."

	| resp |
	[resp := self sendRequest: url,'/_vti_bin/_vti_aut/author.dll' method: {
		 'method' -> ('checkout document:', self extension).
		'service_name' -> '/'.
		'document_name' -> repoPath.
		'force' -> '1'.
		'timeout' -> '0'.
	}.
	resp isSuccess ifFalse:[^self error: resp status].
	self checkResponse: resp content.
	] ensure:[self close].
	^resp
! !

!QSharePointRepository methodsFor: 'initialize' stamp: 'ar 4/13/2010 13:54'!
on: urlPath
	super on: urlPath.
	webClient := QWebClient new initializeFromUrl: urlPath.

	"Does NOT allow simple auth methods because we need to be
	able to make multiple requests with the same credentials."
	webClient allowSimpleAuth: false.

	"Does NOT allow any redirects since SharePoint uses redirects 
	when having invalid requests. We'd rather get an error, thank you."
	webClient allowRedirect: false.

	"Set up authentication handling"
	webClient authCredentialsBlock:[:client :realm :failBlock|
		owner 
			ifNil:[failBlock value]
			ifNotNil:[owner clientAuth: client realm: url fail: failBlock]].
	webClient proxyCredentialsBlock:[:client :realm :failBlock|
		owner 
			ifNil:[failBlock value]
			ifNotNil:[owner proxyAuth: client realm: url fail: failBlock]].
! !

!QSharePointRepository methodsFor: 'initialize' stamp: 'ar 4/16/2010 14:13'!
refresh
	"Refresh the contents of the repository if is cached"

	| fullPath fileLastSavedBy document docPath suffix |
	docMap := Dictionary new.
	(self listServerDocuments: url) do:[:docArray|
		docPath := fullPath := docArray at: 1.
		(fullPath beginsWith: '/') ifFalse:[fullPath := '/', fullPath].
"		fileSize := docArray at: 2.
		fileAuthor := docArray at: 3.
		fileModified := docArray at: 4.	"
		fileLastSavedBy := docArray at: 5.
		suffix := (docPath copyAfterLast: $.).
		document := QSharedDocument new.
		document 
			repoType: 'sharepoint' url: url path: docPath; "also sets sharedName"
			suffix: (docPath copyAfterLast: $.) asUppercase;
			ctime: (QTimeStamp new
						who: fileLastSavedBy
						what: 'checkedin'
						utc: DateAndTime utcSeconds). "XXXX Fixme XXXX"
		(docMap at: (fullPath copyUpToLast: $/) ifAbsentPut:[OrderedCollection new]) add: document.
	].! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2010 11:33'!
removeLock: repoPath
	"Forcefully remove a lock on a checked out document"

	| resp |
	[resp := self sendRequest: url,'/_vti_bin/_vti_aut/author.dll' method: {
		 'method' -> ('uncheckout document:', self extension).
		'service_name' -> '/'.
		'document_name' -> repoPath.
		'force' -> 'true'.
		'rlsshortterm' -> 'false'.
	}.
	resp isSuccess ifFalse:[^self error: resp status].
	self checkResponse: resp content.
	] ensure:[self close].
	^resp
! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 4/2/2010 00:38'!
sendRequest: path method: methodData
	"Send the FrontPage RPC request"
	^self sendRequest: path method: methodData do: nil! !

!QSharePointRepository methodsFor: 'frontpage rpc' stamp: 'ar 4/16/2011 17:23'!
sendRequest: path method: methodData do: aBlock
	"Send the FrontPage RPC request"
	| postData request |

	postData := String streamContents:[:s|
		"encode method data"
		methodData do:[:assoc|
			s  nextPutAll: assoc key; 
				nextPut: $=; nextPutAll: 
				assoc value encodeForHTTP.
		] separatedBy:[s nextPut:$&].
	].
	request := webClient requestWithUrl: path.
	request method: 'POST'.
	request headerAt: 'Content-Type' put: 'application/x-www-form-urlencoded'.
	request headerAt: 'Content-Length' put: postData size.
	request headerAt: 'User-Agent' put: 'OpenQwaq'.
	request headerAt: 'X-Vermeer-Content-Type' put: 'application/x-www-form-urlencoded'.
	aBlock ifNotNil:[aBlock value: request].
	^webClient sendRequest: request content: postData readStream size: postData size
! !

!QSharePointRepository methodsFor: 'actions' stamp: 'ar 4/16/2011 17:23'!
upload: repoPath stream: aStream do: aBlock
	"Upload a document to the repository.
	Does NOT close the client to allow delegated server auth to work.

	WARNING: This will currently not work with basic or digest auth!!"

	| request response |
	"To aquire authentication credentials, we upload the file with zero length first"
	request := webClient requestWithUrl: (url, '/', repoPath).
	request method: 'PUT'.
	request headerAt: 'Content-Type' put: 'application/octet-stream'. "XXXX: fixme"
	request headerAt: 'User-Agent' put: 'OpenQwaq'.
	request headerAt: 'Content-Length' put: 0.
	aBlock ifNotNil:[aBlock value: request].
	response := webClient sendRequest: request.
	response isSuccess ifFalse:[^response].

	"We have successfully authenticated. Upload the file for real, assuming
	that authentication is connection-oriented. This should be replaced by
	proper pre-authentication in WebClient but since we expect to see mostly
	NTLM / Negotiate  we can just fire another request."
	request := webClient requestWithUrl: (url, '/', repoPath).
	request method: 'PUT'.
	request headerAt: 'Content-Type' put: 'application/octet-stream'. "XXXX: fixme"
	request headerAt: 'User-Agent' put: 'OpenQwaq'.
	request headerAt: 'Content-Length' put: aStream size.
	response := webClient sendRequest: request content: aStream size: aStream size. 
	response content.

	^response
! !

!QSharePointRepository methodsFor: 'accessing' stamp: 'ar 4/5/2010 15:42'!
webClient
	"Answer the webClient used to retrieve the contents of the repository"

	^webClient! !

CTreeItem subclass: #QRepositoryTreeItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QRepositoryTreeItem commentStamp: '<historical>' prior: 0!
A tree item for the repository list.!

QRepositoryTreeItem defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="repository" toSet="repository:" changeEvent="repositoryChanged">repository</field>
</fields>'!

!QRepositoryTreeItem class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRepositoryTreeItem class methodsFor: 'instance creation' stamp: 'ar 2/19/2010 15:34'!
repository: aRepository path: aPath
	^self new repository: aRepository path: aPath! !

!QRepositoryTreeItem methodsFor: 'accessing' stamp: 'ar 5/6/2010 14:34'!
documents
	"Return documents from repository"
	^repository listDocuments: value! !

!QRepositoryTreeItem methodsFor: 'templates' stamp: 'ar 4/14/2010 11:38'!
getChildren
	value ifEmpty:[self refresh].
	^(repository listFolders: value)collect:[:each| self class repository: repository path: each]! !

!QRepositoryTreeItem methodsFor: 'templates' stamp: 'ar 2/19/2010 15:34'!
getIcon
	"Retrieve the icon for this entry"
	^nil! !

!QRepositoryTreeItem methodsFor: 'templates' stamp: 'ar 4/7/2010 15:40'!
getLabel
	(value copyAfterLast: $/) ifNotEmpty:[:lbl| ^lbl].
	(repository url copyAfterLast: $/) ifNotEmpty:[:lbl| ^lbl].
	^repository url asUrl authority! !

!QRepositoryTreeItem methodsFor: 'templates' stamp: 'ar 4/2/2010 15:00'!
hasChildren
	value ifEmpty:[^true].
	^repository hasFoldersAt: value! !

!QRepositoryTreeItem methodsFor: 'initialize' stamp: 'ar 4/14/2010 12:01'!
refresh
	"Refresh the repository"
	| cc |
	[
		cc := container mouseCursor.
		[container mouseCursor: Cursor wait.
		repository refresh] ensure:[container mouseCursor: cc].
	] on: Error do:[:ex|
		^self inform: 'Unable to update repository:', String cr, ex description.
	].! !

!QRepositoryTreeItem methodsFor: 'accessing' stamp: 'ar 2/19/2010 15:16'!
repository
	"Answer the repository of the receiver"
	<bewareOf: #repositoryChanged>
	^self propertyValueAt: #repository! !

!QRepositoryTreeItem methodsFor: 'accessing' stamp: 'ar 2/19/2010 15:16'!
repository: aValue
	"Modify the receiver's repository"
	^self propertyValueAt: #repository put: aValue with: #repositoryChanged! !

!QRepositoryTreeItem methodsFor: 'initialize' stamp: 'ar 2/19/2010 15:56'!
repository: aRepository path: aPath
	repository := aRepository.
	value := aPath.
! !

QDocumentTool subclass: #QRepositoryBrowserTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QRepositoryBrowserTool commentStamp: '<historical>' prior: 0!
A repository browsing document tool.!

QRepositoryBrowserTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="addButton" toSet="addButton:" changeEvent="addButtonChanged">addButton</field>
	<field toGet="delButton" toSet="delButton:" changeEvent="delButtonChanged">delButton</field>
	<field toGet="siteHeader" toSet="siteHeader:" changeEvent="siteHeaderChanged">siteHeader</field>
	<field toGet="siteList" toSet="siteList:" changeEvent="siteListChanged">siteList</field>
	<field toGet="selectedSiteNode" toSet="selectedSiteNode:" changeEvent="selectedSiteNodeChanged">selectedSiteNode</field>
</fields>'!

!QRepositoryBrowserTool class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 5/7/2010 12:51'!
addButton
	"Answer the addButton of the receiver"
	<bewareOf: #addButtonChanged>
	^self propertyValueAt: #addButton! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 5/7/2010 12:51'!
addButton: aValue
	"Modify the receiver's addButton"
	^self propertyValueAt: #addButton put: aValue with: #addButtonChanged! !

!QRepositoryBrowserTool methodsFor: 'menu' stamp: 'ar 5/3/2010 11:53'!
addSharePointSite
	"Add a SharePoint repository"

	| url repo item |
	url := UIManager default request: 'Paste the SharePoint Site URL' initialAnswer: ''.
	url ifEmpty:[^self].
	[
		"Canonicalize the url"
		url := url asUrl.
		(url scheme = 'http') ifFalse:[self error: 'Only http urls are supported'].
		repo := QSharePointRepository on: url toText.
		repo owner: owner.
		repo checkValid ifFalse:[^self inform: 'The repository url is not valid'].
	] on: Error do:[:ex|
		^self inform: 'The repository url is not valid:', String cr, ex description.
	].
	QDocumentRepository cache at: repo url put: repo.

	item := QRepositoryTreeItem repository: repo path: ''.
	siteList rootNodes: (siteList rootNodes copyWith: item).
	self storePreferences.
! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 5/7/2010 12:51'!
delButton
	"Answer the delButton of the receiver"
	<bewareOf: #delButtonChanged>
	^self propertyValueAt: #delButton! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 5/7/2010 12:51'!
delButton: aValue
	"Modify the receiver's delButton"
	^self propertyValueAt: #delButton put: aValue with: #delButtonChanged! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/14/2010 16:56'!
docToolDrop: document at: aGlobalPoint fromService: svcRecord

	| repoPath docPath checkinInfo |

	true ifTrue:[^false]. "to be done later..."

	selectedSiteNode ifNil:[^self inform: 'Please select a repository'].
	[repoPath := selectedSiteNode value, '/', (document get: #shortName).
	(repoPath beginsWith: '/') ifTrue:[repoPath := repoPath allButFirst].
	docPath := [ document get: #asServiceManagerPath ] on: Error do: [ nil ].
	] on: Error do:[:ex| 
		self inform: 'Cannot import document: ', String cr, ex description.
		^false
	].

	checkinInfo := QCheckinInfo new.
	checkinInfo serverPath: docPath;
					repoType: selectedSiteNode repository repoType;
					repoUrl: selectedSiteNode repository url;
					repoPath: repoPath;
					upload: true;
					locked: false;
					deleteFile: false.
	owner onCheckinDocument: checkinInfo.
	checkinInfo success ifTrue:[
		selectedSiteNode repository refresh.
		self onUpdate.
	].

	^checkinInfo success
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/13/2010 18:14'!
dragDocument: document

	| dragLabel offset nextPos delta |

	(self checkDraggable: document) ifFalse: [ ^ self ].

	dragLabel := QDocumentDragIcon new.
	dragLabel document: (document).
	dragLabel addToWorld: world.

	offset := dragLabel cursorPoint.
	hand forEach: #mouseMove do:[
		nextPos := dragLabel cursorPoint.
		delta := nextPos - offset.
		dragLabel transform: ((COffsetTransform withOffset: delta) 
			transformedBy: dragLabel transform).
	] until: #mouseUp.
	
	(self containsPoint: self cursorPoint) ifTrue: [
		dragLabel dragReject.
		^ false
	].

	"Send the actual request through the owner,
	 which steers it either back to me for online drop,
	 or delegates to the service chooser for offline drop if we're not yet logged in."
	(owner notNil and: [ owner repositoryDrop: document at: (hand position) fromService: service ]) 
	ifTrue: [
		dragLabel dragAccept.
	] ifFalse: [
		dragLabel dragReject.
	].! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'ar 4/14/2010 12:07'!
fetchPreferences
	"Fetch the repository from user preferences"
	| xmlBlob xmlNode type url repo item roots |
	xmlBlob := owner preferences documentRepositories.
	xmlBlob ifNil:[^self].

	roots := #().
	xmlNode := XMLDOMParser parseDocumentFrom: xmlBlob readStream.
	xmlNode elements do:[:elem|
		elem name == #repository ifTrue:[
			type := elem contentStringAt: 'repoType'.
			url := elem contentStringAt: 'repoUrl'.
			repo := QDocumentRepository cache at: url
				ifAbsentPut:[QDocumentRepository type: type url: url owner: owner].
			item := QRepositoryTreeItem repository: repo path: ''.
			roots := roots copyWith: item.
		].
	].
	siteList rootNodes: roots.

! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'ar 5/7/2010 12:50'!
initialize
	super initialize.
	self define: #siteHeader as: QDocColumnHeader new.
	self define: #siteList as: CTreeWidget new.
	self define: #addButton as: CPushButton new.
	self define: #delButton as: CPushButton new.
	siteList rootNodes: #().! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 3/30/2010 17:56'!
inspectDocument

	documents selection basicInspect.! !

!QRepositoryBrowserTool methodsFor: 'layout' stamp: 'ar 5/12/2010 11:39'!
layoutEverything
	| box iconwid |
	box := self borderedContentBounds.

	siteHeader 
		extent: (siteList width @ 24);
		topLeft: box topLeft.

	headers
		extent: (box right - siteHeader right @ 24);
		topLeft: siteHeader topRight.

	iconwid := 3 * self footerHeight // 2.
	footer
		extent:  (box width - iconwid  @ (self footerHeight));
		fullBounds;
		bottomLeft: (box bottomLeft + (iconwid @-1)).
	footerIcon 
		extent: (iconwid+1 @ self footerHeight);
		topLeft: (box bottomLeft - (-1@self footerHeight+1)).

	documents layoutFrame topOffset: headers bottom - 2.
	documents layoutFrame bottomOffset: 0 - self footerHeight - searchLabel height - 6.

	siteList layoutFrame topFraction: documents layoutFrame topFraction.
	siteList layoutFrame topOffset: documents layoutFrame topOffset.
	siteList layoutFrame bottomFraction: documents layoutFrame bottomFraction.
	siteList layoutFrame bottomOffset: -58.

	searchLabel 
			width: (documents width);
			topLeft: (documents bottomLeft + (0@ -1)).
	searchText
			width: (documents width - 112);
			topLeft: (documents bottomLeft + (104@8)).

	footer width: footer width - siteList width.

	footer right: documents right.
	footerIcon right: footer left+1.

	addButton extent: 25@25.
	addButton topLeft: (siteList bottomLeft).
	delButton extent: 25@25.
	delButton topLeft: (addButton topRight).
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/14/2010 15:59'!
listDocuments
	"Get the current list of all documents and pass it on to sorting"
	self mouseCursor: Cursor wait.
	[allEntries := selectedSiteNode ifNil:[#()] ifNotNil:[selectedSiteNode documents asArray].
	self sort] ensure:[self mouseCursor: nil].! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 5/7/2010 14:45'!
onAddButtonFire
	<on: fire in: addButton>
	self addSharePointSite.
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 5/3/2010 11:53'!
onContextMenu
	| treeMenu item |
	treeMenu := CMenu new.
	item := treeMenu add: 'Open Web Browser' target: self action: #openWebBrowser.
	item enabled: selectedSiteNode notNil.
	treeMenu addSeparator.
	treeMenu add: 'Add SharePoint Site...' target: self action: #addSharePointSite.
	item := treeMenu add: 'Remove Site' target: self action: #removeSharePointSite.
	item enabled: selectedSiteNode notNil.
	QStyles installMenuFontInMenu: treeMenu.
	treeMenu open.
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 5/7/2010 14:46'!
onDelButtonFire
	<on: fire in: delButton>
	self removeSharePointSite.
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 5/7/2010 14:42'!
onExpandedChanged
	| extras |

	super onExpandedChanged.

	extras := {documents . siteList. siteHeader. addButton. delButton}.

	self isExpanded ifTrue: [ 
		extras do: [ : e | self remove:e; add: e ].
	] ifFalse: [
		self removeAll: extras.
	].
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/2/2010 13:58'!
onSiteMenu
	<on: yellowButtonDown in: siteList>
	self onContextMenu.! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/14/2010 12:13'!
onSiteSelectionChanged
	| cursor |
	<on: cursorChanged in: siteList>
	cursor := siteList cursor.
	selectedSiteNode := cursor > 0 ifTrue:[siteList treeNodes at: cursor].
	self updateTitle.
	footer label: ' This is a label '.
"selectedSiteNode repository url, selectedSiteNode value."
	self onUpdate.! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/19/2010 14:39'!
openWebBrowser
	"Open a web browser on the currently selected site"
	| url path |
	selectedSiteNode ifNil:[^self inform: 'Please select a site'].
	url := selectedSiteNode repository url.
	(url endsWith: '/') ifTrue:[url := url allButLast].
	url := url, (((path := selectedSiteNode value) beginsWith: '/') ifTrue:[path] ifFalse:['/',path]).
	owner shellOpen: url documentDescription: 'URL' 
				applicationDescription: 'Web browser'.! !

!QRepositoryBrowserTool methodsFor: 'menu' stamp: 'ar 5/7/2010 14:55'!
removeSharePointSite
	"Remove a SharePoint repository"

	| roots |
	selectedSiteNode ifNil:[^self].
	(self confirm: 'Remove this repository?\\' withCRs, selectedSiteNode repository url) ifFalse:[^self].
	roots := siteList rootNodes reject:[:node| node repository == selectedSiteNode repository].
	siteList removeAll; waitTick.
	siteList rootNodes: roots.
	self storePreferences.
	self onUpdate.! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'ar 4/14/2010 14:56'!
restoreState: xmlState
	"Fetch preferences when reopening"
	super restoreState: xmlState.
	self startScript: #fetchPreferences.
! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 2/19/2010 16:04'!
selectedSiteNode
	"Answer the selectedSiteNode of the receiver"
	<bewareOf: #selectedSiteNodeChanged>
	^self propertyValueAt: #selectedSiteNode! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 2/19/2010 16:04'!
selectedSiteNode: aValue
	"Modify the receiver's selectedSiteNode"
	^self propertyValueAt: #selectedSiteNode put: aValue with: #selectedSiteNodeChanged! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'sn 5/8/2011 21:09'!
setupCostume
	super setupCostume.

	self defaultExtent: (580@300).
	self extent: (self defaultExtent).

	self setupBorderedPanel: siteList.
	(siteList layoutFrame) 
		rightFraction: 0.3;
		rightOffset: 0.
	(documents layoutFrame) 
		leftFraction: 0.3;
		leftOffset: 0.

	addButton 
		label: '+';
		font: (QStyles largeControlFont);
		textEmphasis: 1.
	self add: addButton.

	delButton
		label: '-';
		font: (QStyles largeControlFont);
		textEmphasis: 1.
	self add: delButton.

	self title: 'SharePoint Tool' translateMe! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'ar 4/14/2010 15:43'!
setupHeader

	siteHeader label: 'Repository'.
	siteHeader layoutFrame: CLayoutFrame new.
	siteHeader sortSelector: #shortName.
	siteHeader active: false.
	siteHeader locked: true.

	siteHeader fillColors: (CWidgetLibrary default gradientColors); fillStyle: #verticalGradient.
	siteHeader borderColor: (Color gray alpha: 0.3); 
			 borderWidth: 1;
			 borderStyle: #simple;
			 vResizing: #rigid;
			 height: 21.

	self add: siteHeader.

	super setupHeader.! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 4/14/2010 12:19'!
siteHeader
	"Answer the siteHeader of the receiver"
	<bewareOf: #siteHeaderChanged>
	^self propertyValueAt: #siteHeader! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 4/14/2010 12:19'!
siteHeader: aValue
	"Modify the receiver's siteHeader"
	^self propertyValueAt: #siteHeader put: aValue with: #siteHeaderChanged! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 2/19/2010 15:03'!
siteList
	"Answer the siteList of the receiver"
	<bewareOf: #siteListChanged>
	^self propertyValueAt: #siteList! !

!QRepositoryBrowserTool methodsFor: 'accessing' stamp: 'ar 2/19/2010 15:03'!
siteList: aValue
	"Modify the receiver's siteList"
	^self propertyValueAt: #siteList put: aValue with: #siteListChanged! !

!QRepositoryBrowserTool methodsFor: 'initialize' stamp: 'ar 4/14/2010 11:37'!
storePreferences
	"Store the repository list in user preferences"

	| xmlBlob writer |
	xmlBlob := String streamContents:[:s|
		writer := XMLWriter on: s.
		siteList rootNodes do:[:item|
			writer startTag: 'repository'; endTag.
				writer tag: 'repoType' pcData: item repository repoType.
				writer tag: 'repoUrl' pcData: item repository repoUrl.
			writer endTag: 'repository'.
		].
	].
	owner preferences documentRepositories: xmlBlob.
! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 4/2/2010 17:50'!
summarize: doc
	(doc == nil and:[selectedSiteNode notNil]) ifTrue:[
		footer label: 	'Site:     ', selectedSiteNode repository url, String cr,
					'Path:    ', selectedSiteNode value, String cr,
					'Type:    Document Library'.
		footerIcon graphic: nil.
	] ifFalse:[super summarize: doc].! !

!QRepositoryBrowserTool methodsFor: 'events' stamp: 'ar 5/4/2010 17:58'!
updateTitle
	selectedSiteNode ifNil:[
		self title: 'SharePoint Tool'
	] ifNotNil:[
		self title: 'SharePoint Tool: ', selectedSiteNode repository url.
	].! !

Error subclass: #QDocumentIsLocked
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QDocumentIsLocked commentStamp: '<historical>' prior: 0!
An exception signaled if a document is currently locked by another user.!

!QDocumentIsLocked class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

WebClient subclass: #QWebClient
	instanceVariableNames: 'allowSimpleAuth'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Qwaq-SharePoint'!

!QWebClient commentStamp: 'ar 3/30/2010 12:54' prior: 0!
QWebClient extends WebClient with support for NTLM and SPNEGO auth on Windows.!

!QWebClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QWebClient class methodsFor: 'cache' stamp: 'ar 4/1/2010 18:50'!
cache
	"Answer the shared cache"

	^Cache ifNil:[Cache := Dictionary new].
! !

!QWebClient class methodsFor: 'cache' stamp: 'ar 4/1/2010 18:50'!
cache: aDictionary
	"Install a shared cache"

	Cache := aDictionary! !

!QWebClient class methodsFor: 'cache' stamp: 'ar 4/1/2010 18:50'!
resetCache
	"Reset the cache"

	self cache: nil
! !

!QWebClient methodsFor: 'accessing' stamp: 'ar 4/2/2010 18:33'!
allowSimpleAuth
	"Boolean indicating whether we allow the 'simple' auth methods
	that are not connection-oriented. Can be problematic in some use-cases."

	^allowSimpleAuth! !

!QWebClient methodsFor: 'accessing' stamp: 'ar 4/2/2010 18:33'!
allowSimpleAuth: aBool
	"Boolean indicating whether we allow the 'simple' auth methods
	that are not connection-oriented. Can be problematic in some use-cases."

	allowSimpleAuth := aBool
! !

!QWebClient methodsFor: 'authentication' stamp: 'ar 4/2/2010 18:33'!
authDispatch: request from: response header: authHeader params: params
	"Dispatch on an authentication method. Factored out to allows subclasses
	to extend the set of supported authentication methods"

	(authHeader copyUpTo: Character space) caseOf: {
		['NTLM'] -> [self ntlmAuth: request from: response 
							header: authHeader  params: params].
		['Negotiate'] -> [self spnegoAuth: request from: response 
							header: authHeader  params: params].
	} otherwise:[
		allowSimpleAuth ifTrue:[
			"Only if we allow simple auth methods"
			super authDispatch: request from: response header: authHeader params: params
		].
	].! !

!QWebClient methodsFor: 'authentication' stamp: 'ar 3/30/2010 14:43'!
flushAuthState: params
	"Fliush authentication state that should not been preserved 
	inbetween failed attempts to authenticate. 
	Subclasses may extend this method for custom authentication."

	super flushAuthState: params.
	self primitiveAuthDestroy: (params removeKey: #authHandle ifAbsent:[^self]).! !

!QWebClient methodsFor: 'initialize' stamp: 'ar 4/2/2010 18:32'!
initialize
	super initialize.
	allowSimpleAuth := true.

! !

!QWebClient methodsFor: 'authentication' stamp: 'ar 4/30/2010 11:18'!
ntlmAuth: request from: response header: header params: params
	"Perform NTLM authentication"

	| token status authHandle user pass domain |
	"NTLM is a multi-phase process; allow re-entering"
	(params at: #authMethod ifAbsent:['NTLM']) = 'NTLM' ifFalse:[^self].
	authHandle := params at: #authHandle ifAbsent:[nil].
	authHandle ifNil:[
		"Initiate new authentication session.
		Missing username / password indicates logged on users' credentials"
		user := params at: #username ifAbsent:[nil].
		pass := params at: #password ifAbsent:[nil].
		(user notNil and:[(user indexOf: $\) > 0]) ifTrue:[
			domain := (user copyUpTo: $\) asUppercase.
			user := user copyAfter: $\.
		].
		authHandle := self primitiveAuthInitiate: 'NTLM' 
			user: user pass: pass value domain: domain principal: ''.
		authHandle ifNil:[^nil]. "auth plugin missing?"
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^self primitiveAuthDestroy: authHandle]. "something went wrong"
		params at: #authMethod put: 'NTLM'.
		params at: #authHandle put: authHandle.
		params at: #authResponse put: 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	] ifNotNil:[
		"Continue authentication"
		token := (header copyAfter: Character space) base64Decoded.
		"An empty token during an ongoing NTLM session indicates invalid credentials"
		token ifEmpty:[^self].
		status := self primitiveAuthContinue: authHandle token: token.
		status < 0 ifTrue:[^self error: 'Internal authentication failure (status code ', status,')'].
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^self error: 'Internal authentication failure (no token generated)'].
		params at: #authResponse put: 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	].! !

!QWebClient methodsFor: 'primitives' stamp: 'ar 3/30/2010 12:41'!
primitiveAuthContinue: session token: token
	"Primitive. Continue an authentication session.
	Arguments:
		session - the auth session identifier.
		token - the token received from the server
	Returns:
		<0 	- Error. The error code is platform specific.
		0 	- OK. The session is authenticated.
		1	- Another server-roundtrip is needed.
	"

	<primitive: 'primitiveAuthContinue' module: 'WebAuthPlugin'>
	^-1! !

!QWebClient methodsFor: 'primitives' stamp: 'ar 3/30/2010 12:41'!
primitiveAuthDestroy: session
	"Primitive. Destroy an authentication session.
	Arguments:
		session - the auth session identifier.
	Returns:
		<0 	- Error. The error code is platform specific.
		0 	- OK.
	"

	<primitive: 'primitiveAuthDestroy' module: 'WebAuthPlugin'>
	^-1! !

!QWebClient methodsFor: 'primitives' stamp: 'ar 4/30/2010 11:17'!
primitiveAuthInitiate: method user: user pass: pass domain: domain principal: principal
	"Primitive. Initiate an authentication method.
	Arguments:
		method - the name of the authentication method
		user - the user name (optional)
		pass - the password (optional)
		domain - the authentication domain (optional)
		principal - the Kerberos service principal name
	Returns:
		session - the auth session identifier.
	If any of the arguments are missing, the currently logged on
	user will be used. The names of the authentication methods can be:
		NTLM - for NTLM authentication.
		Negotiate - For Microsoft Negotiate
	See also RFC 4559 for details."

	<primitive: 'primitiveAuthInitiate' module: 'WebAuthPlugin'>
	^nil! !

!QWebClient methodsFor: 'primitives' stamp: 'ar 3/30/2010 12:41'!
primitiveAuthToken: session
	"Primitive. Answer the next token for the authentication.
	Arguments:
		session - the ntml session identifier
	Returns:
		token - the token to continue the authentication with."

	<primitive: 'primitiveAuthToken' module: 'WebAuthPlugin'>
	^nil! !

!QWebClient methodsFor: 'authentication' stamp: 'ar 4/30/2010 11:26'!
spnegoAuth: request from: response header: header params: params
	"Perform Negotiate (SPNEGO) authentication"

	| token status authHandle user pass domain principal |
	"Negotiate is a multi-phase process; allow re-entering"
	(params at: #authMethod ifAbsent:['Negotiate']) = 'Negotiate' ifFalse:[^self].
	authHandle := params at: #authHandle ifAbsent:[nil].
	authHandle ifNil:[
		"Initiate new authentication session.
		Missing username / password indicates logged on users' credentials"
		user := params at: #username ifAbsent:[nil].
		pass := params at: #password ifAbsent:[nil].
		(user notNil and:[(user indexOf: $\) > 0]) ifTrue:[
			domain := (user copyUpTo: $\) asUppercase.
			user := user copyAfter: $\.
		].
		"Construct Kerberos service principal name"
		principal := 'HTTP/', self server.
		authHandle := self primitiveAuthInitiate: 'Negotiate' 
			user: user pass: pass value domain: domain principal: principal.
		authHandle ifNil:[^nil]. "auth plugin missing?"
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^self primitiveAuthDestroy: authHandle]. "something went wrong"
		params at: #authMethod put: 'Negotiate'.
		params at: #authHandle put: authHandle.
		params at: #authResponse put: 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	] ifNotNil:[
		"Continue authentication"
		token := (header copyAfter: Character space) base64Decoded.
		"An empty token during an ongoing Negotiate session indicates invalid credentials"
		token ifEmpty:[^self].
		status := self primitiveAuthContinue: authHandle token: token.
		status < 0 ifTrue:[^self error: 'Internal authentication failure (status code ', status,')'].
		token := self primitiveAuthToken: authHandle.
		token ifNil:[^self error: 'Internal authentication failure (no token generated)'].
		params at: #authResponse put: 
			(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
	].! !
QDocumentRepository initialize!
